#!/bin/sh

# Bashscript which is executed by bash *AFTER* complete installation is done
# (but *BEFORE* postupdate). Use with caution and remember, that all systems
# may be different! Better to do this in your own Pluginscript if possible.
#
# Exit code must be 0 if executed successfull.
#
# Will be executed as user "loxberry".
#
# We add 5 arguments when executing the script:
# command <TEMPFOLDER> <NAME> <FOLDER> <VERSION> <BASEFOLDER>
#
# For logging, print to STDOUT. You can use the following tags for showing
# different colorized information during plugin installation:
#
# <OK> This was ok!"
# <INFO> This is just for your information."
# <WARNING> This is a warning!"
# <ERROR> This is an error!"
# <FAIL> This is a fail!"

# To use important variables from command line use the following code:
ARGV0=$0 # Zero argument is shell command
#echo "<INFO> Command is: $ARGV0"

ARGV1=$1 # First argument is temp folder during install
#echo "<INFO> Temporary folder is: $ARGV1"

ARGV2=$2 # Second argument is Plugin-Name for scipts etc.
#echo "<INFO> (Short) Name is: $ARGV2"

ARGV3=$3 # Third argument is Plugin installation folder
#echo "<INFO> Installation folder is: $ARGV3"

ARGV4=$4 # Forth argument is Plugin version
#echo "<INFO> Installation folder is: $ARGV4"

ARGV5=$5 # Fifth argument is Base folder of LoxBerry
#echo "<INFO> Base folder is: $ARGV5"

echo "<WARNING> ===================================================================================="
echo "<WARNING> Please REBOOT your LoxBerry after installation."
echo "<WARNING> After first reboot the daemon needs to install some packages. That takes around 5 min."
echo "<WARNING> The Service starts automaticly after that. This is only necessary once."
echo "<WARNING> ===================================================================================="
echo "<WARNING> Bitte LoxBerry nach der Installation REBOOTEN."
echo "<WARNING> Nach dem ersten Neustart muss der daemon noch Pakete nachinstallieren. Dauer ca. 5 Min."
echo "<WARNING> Der Service startet dann automatisch. Das ist nur einmalig nötig!"  
echo "<WARNING> ===================================================================================="

# Exit with Status 0
exit 0
